#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "ppc.h"
#include "tmesh.h"

class Scene {
public:
  PPC *ppc, *refppc;
  GUI *gui;
  FrameBuffer *fb, *photo, *photoR;
  FrameBuffer *canvas;
  PPC *canvasPPC, *photoPPC, *photoRPPC;
  Scene();
  void DBG();
  void RenderExtrinsicCalibration();
  void Render();
  void Setup();
  void ProjectiveTMSetup();
  void PanoramaSetup();
  void PanoramaRender();
  TMesh **tms;
  int tmsN;
  V3 *markers;
  int markersN;
  void ExtrinsicCalibrationBF();
  void PanoRegister();
  float PanoError(PPC *ppc0, FrameBuffer *fb0, PPC *ppc1, FrameBuffer *fb1);

  void RenderGeometry(FrameBuffer *cfb, PPC *cppc);

  void StereoSetup();
  PPC *leftPPC, *rightPPC;
  FrameBuffer *leftFB, *rightFB;
  int leftPoint[2];
  int rightPoint[2];

};

extern Scene *scene;
